﻿#target photoshop

function ALCE2_main(radius, turbo, ALCEopacity)
{
    if (turbo == null) 
    {
        turbo = false; // è il default nel caso il secondo parametro NON SIA SPECIFICATO
    }
    if (ALCEopacity == null) 
    {
        ALCEopacity = 100; // è il default nel caso il secondo parametro NON SIA SPECIFICATO
    }
    // alert("turbo è " + turbo)
    switch (app.activeDocument.mode) 
    {
        case DocumentMode.BITMAP:
        case DocumentMode.MULTICHANNEL:
        case DocumentMode.INDEXEDCOLOR:
        case DocumentMode.DUOTONE:
        alert("Unsupported mode! Image can't be Bitmap, Duotone, Multichannel or Indexed Color, sorry.")
        return;
        break;
        default: 
        ;
    }
    
    try
    {
        var origDoc = app.activeDocument
        if (turbo == false || (dimCheck(radius) == 1)) // non è attivo lo speed
        {
            app.activeDocument.suspendHistory ("ALCE2_" + radius, "selectComposite(); var dupDoc = app.activeDocument.duplicate(\"ALCE2 \" + radius, true);  app.activeDocument.suspendHistory (\"ALCE2 \"+ radius,\"ALCE2_core(radius)\")")
        }
        else // è attivo lo speed
        {
            app.activeDocument.suspendHistory ("ALCE2_" + radius, "selectComposite(); var dupDoc = app.activeDocument.duplicate(\"ALCE2 \" + radius, true);  app.activeDocument.suspendHistory (\"ALCE2 \"+ radius,\"ALCE2_core_LR(radius)\")")
        }
        app.activeDocument.activeLayer.name = "ALCE2 " + radius
        app.activeDocument.activeLayer.duplicate (origDoc, ElementPlacement.PLACEATBEGINNING )
        app.activeDocument.close (SaveOptions.DONOTSAVECHANGES);
        app.activeDocument = origDoc;
        app.activeDocument.activeLayer.opacity = ALCEopacity;
        
        // OCCHIO!!!
        // senza queste due righe non lascia traccia in ScriptingListener!!
         isCancelled = false; // if get here, definitely executed
        return false; // no error
     }
    catch(e)
    {
        if (e.number == 8007) 
        { 
            ; alert ("The script has been halted! You will now get back to your original, untouched image.")
            var isTemp = false;
            var isAlce = false;
            for (i = 0; i< app.documents.length; i++)
            {
                if(app.documents[i].name == "Temp") {isTemp = true}    
                if(app.documents[i].name == "ALCE2 " + radius) {isAlce = true}
            }
            if (isTemp) {app.documents.getByName("Temp").close(SaveOptions.DONOTSAVECHANGES)}
            if (isAlce) {app.documents.getByName("ALCE2 " + radius).close(SaveOptions.DONOTSAVECHANGES)}
        } 
        else
        { 
            //other error code here, "throw e" will display the error, 
            ; throw e; 
         };
     }; 
}






// FUNZIONI VARIE
// ==========================================
// seleziona il canale myChannel (tra virgolette) e rende visibile il composito
function selectChannel(myChannel) 
{
    app.activeDocument.activeChannels = [app.activeDocument.channels.getByName(myChannel)];
//~     app.activeDocument.channels[0].visible = true;
//~     app.activeDocument.channels[1].visible = true;
//~     app.activeDocument.channels[2].visible = true;
    app.activeDocument.channels.getByName(myChannel).visible = false;
 }

function selectComposite() 
{   
     if (app.activeDocument.mode != DocumentMode.GRAYSCALE)
     {
         var docType = "";
         switch (app.activeDocument.mode) 
        {
            case DocumentMode.LAB:      
                var docType= "Lab "
                break;
            case DocumentMode.RGB:
                var docType= "RGB "
                break;
            case DocumentMode.CMYK:
                var docType= "CMYK"
                break;
        }
        var idslct = charIDToTypeID( "slct" );
        var desc84 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
        var ref52 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idChannel = charIDToTypeID( docType );
        ref52.putEnumerated( idChnl, idChnl, idChannel );
        desc84.putReference( idnull, ref52 );
        executeAction( idslct, desc84, DialogModes.NO );
    }
}

function filterRounds(radius, modulo) // quanti giri di Max o Min vanno fatti. Modulo è 100 per maxmin, 250 per GBlur.
{
	var rounds = Math.floor(radius/modulo)
	if (radius % modulo == 0) {return rounds}
	else return (rounds+1)
}

// =======================================================
// Function to apply Image - 
//
//blending modes as follows:
// "PrsT" = NORMAL
// "Ovrl" = OVERLAY
// "Dfrn" = DIFFERENCE // non usare, usa Subtract, pirla.
// "Mltp" = MULTIPLY
// "Drkn" = Darken
// for "linearDodge" = LINEARDODGE = ADD :-)
//
// use the "channel" with quotes!!

function myApply(channel, blending) {
	//alert(blending)
	function cTID(s) { return app.charIDToTypeID(s); };
	function sTID(s) { return app.stringIDToTypeID(s); };
	var desc170 = new ActionDescriptor();
	var desc171 = new ActionDescriptor();
	var ref117 = new ActionReference();
	ref117.putName( cTID('Chnl'), channel );
	desc171.putReference( cTID('T   '), ref117 );
	desc171.putEnumerated( cTID('Clcl'), cTID('Clcn'), cTID(blending) );
	if (blending == ("Sbtr" || "Add"))
	{ 
		desc171.putDouble( cTID('Scl '), 1.000000 );
		desc171.putInteger( cTID('Ofst'), 0 );
	}

	desc171.putBoolean( cTID('PrsT'), true );
	desc170.putObject( cTID('With'), cTID('Clcl'), desc171 );
    executeAction( cTID('AppI'), desc170, DialogModes.NO );
};


// =======================================================
// applica da un altro documento
// "from" è  il nome del documento

function myApplyFrom(from, channel, blending) {
  function cTID(s) { return app.charIDToTypeID(s); };
  function sTID(s) { return app.stringIDToTypeID(s); };

    var desc327 = new ActionDescriptor();
        var desc328 = new ActionDescriptor();
            var ref240 = new ActionReference();
            ref240.putEnumerated( cTID('Chnl'), cTID('Chnl'), cTID('RGB ') );
            ref240.putProperty( cTID('Lyr '), cTID('Bckg') );
            ref240.putName( cTID('Dcmn'), from );
        desc328.putReference( cTID('T   '), ref240 );
		if (blending != undefined)
		{
			desc328.putEnumerated( cTID('Clcl'), cTID('Clcn'), cTID(blending) );
		}
    desc327.putObject( cTID('With'), cTID('Clcl'), desc328 );
    executeAction( cTID('AppI'), desc327, DialogModes.NO );
};

// ========================================================================================================================================================================

function ALCE2_core(radius)
{
    var startDisplayDialogs = app.displayDialogs
    app.displayDialogs = DialogModes.NO
    const GBLURFACTOR = 0.7;
    var dupDoc = app.activeDocument
     
    dupDoc.flatten()
    dupDoc.channels.removeAll()
     
    if (dupDoc.mode != DocumentMode.LAB)
    {
    dupDoc.convertProfile("Lab Color", Intent.RELATIVECOLORIMETRIC, true, false)
    }
      
    var lightness = dupDoc.channels[0]; // Grab L channel
    
    var original = lightness.duplicate();  // dupe L channel
    original.name = "original";  // name it! here is our original

    var max = original.duplicate();
    max.name = "max"; // max layer is here

    if (radius >10) // just a bit of smoothing
    {
        app.activeDocument.activeLayer.applyMedianNoise(5);
    }

    var min = max.duplicate();
    min.name = "min"; // min is here

    switch (radius >100) 
    {
        
        // ...quando il raggio è maggiore di 100
        case true:
        for (var i = 1; i<filterRounds(radius, 100); i++)
		{
            selectChannel("max");
            dupDoc.activeLayer.applyMaximum(100);
            selectChannel("min");
            dupDoc.activeLayer.applyMinimum(100);
		}
        // non c'è il break;
        // così dopo aver fatto i giri a 100, passa a cascata al caso false e finisce col resto del modulo 100
        
        // ...quando il raggio è minore di 100
        case false:
		if ((radius % 100) != 0)
		{
            selectChannel("max");
			dupDoc.activeLayer.applyMaximum(radius % 100);
             selectChannel("min");
			dupDoc.activeLayer.applyMinimum(radius % 100);
		}
		else
		{
            selectChannel("max");
            dupDoc.activeLayer.applyMaximum(100);
            selectChannel("min");
            dupDoc.activeLayer.applyMinimum(100);
		}
    }

    var gBlurRadius =  radius * GBLURFACTOR; // se 0.7 oppure 1, oppure 1.4... boh!
    switch (gBlurRadius > 250)
    {
        case true:
            for (var j = 1; j<filterRounds(gBlurRadius, 250); j++)
            {
                    selectChannel("max");
                    dupDoc.activeLayer.applyGaussianBlur(250);
                    selectChannel("min");
                    dupDoc.activeLayer.applyGaussianBlur(250);
             }
            
         case false:
            if ((gBlurRadius % 250) != 0)
            {
               selectChannel("max");
               dupDoc.activeLayer.applyGaussianBlur(gBlurRadius % 250);
                selectChannel("min");
               dupDoc.activeLayer.applyGaussianBlur(gBlurRadius % 250);
            }
            else
            {
                selectChannel("max");
                dupDoc.activeLayer.applyGaussianBlur(250);
                 selectChannel("min");
                dupDoc.activeLayer.applyGaussianBlur(250);	
            }
    }

    var maxHalo = max.duplicate();
    maxHalo.name = "MaxH";
    var minHalo = min.duplicate();
    minHalo.name = "MinH";

    selectChannel("MinH");
    dupDoc.activeLayer.applyHighPass(radius);
    selectChannel("MaxH");
    dupDoc.activeLayer.applyHighPass(radius);	
 
    selectChannel("MaxH");
    myApply("MinH", "Ovrl");
    minHalo.remove()

    
    dupDoc.activeChannels = [dupDoc.channels.getByName("max")];
    myApply("min", "Sbtr");
    app.activeDocument.activeLayer.invert();
    myApply("original", "Mltp");
    selectChannel("original");
    myApply("min", "Sbtr");
    myApply("max", "Add ")
    myApply("MaxH", "Ovrl");
    max.remove();
    min.remove();
    maxHalo.remove();
    dupDoc.activeChannels = [dupDoc.channels[0]];
    myApply("original", "PrsT")
    dupDoc.activeChannels = [dupDoc.channels[0], dupDoc.channels[1], dupDoc.channels[2]];
    original.remove()

}

// ========================================================================================================================================================================

function ALCE2_core_LR(radius)	
{																	
	    // PREFERENCES
    var startDisplayDialogs = app.displayDialogs;
    app.displayDialogs = DialogModes.NO;	
    
    const GBLURFACTOR = 0.7;
    var REDFAC =  dimCheck(radius);
  // alert(REDFAC) //
    //ROUTINE
    var myDoc = app.activeDocument
    myDoc.flatten();
    myDoc.channels.removeAll();

    if (myDoc.mode != DocumentMode.LAB)
    {
        myDoc.convertProfile("Lab Color", Intent.RELATIVECOLORIMETRIC, true, false)
    }

    var dupDocLR = myDoc.duplicate("Temp", true);
    app.activeDocument = dupDocLR;

    var originalPreferences = app.preferences.rulerUnits;
    app.preferences.rulerUnits = Units.CM;
                
    var actualHeight = parseFloat(dupDocLR.height.valueOf());   // DA CONTROLLARE
//    alert ("actualHeight = parseFloat(dupDocLR.height.valueOf()) = " + actualHeight = parseFloat(dupDocLR.height.valueOf()))
//    alert ("mentre actualHeight = dupDocLR.height è " + dupDocLR.height)
    var actualWidth = parseFloat(dupDocLR.width.valueOf());     // DA CONTROLLARE
    var ratio = actualHeight / actualWidth;
    var finalHeight = (actualHeight/REDFAC);
    var finalWidth = (finalHeight/ratio);
    var docRes = dupDocLR.resolution;
 //   alert(docRes) //
    app.activeDocument.resizeImage(finalWidth, finalHeight, docRes, ResampleMethod.BICUBIC);



    // Start the duplication dance

    var lightness = dupDocLR.channels[0]; // Grab L channel
    var original = lightness.duplicate();  // dupe L channel
    original.name = "ORIG"; // ORIG from L channel

    var max = original.duplicate();
    max.name = "Max"; //Max as L duplicate

    radius = parseInt (radius/REDFAC)

    //			if (radius > 10) // Smoothing for radius greater than 10
    //			{				
    //				asAL.applyMedianNoise(5);
    //			}					

    var min = max.duplicate();
    min.name = "Min"; // Min as Max duplicate			

    switch (radius > 100)
    {
        case true: //if the radius is bigger than 100       
            for (var i = 1; i<filterRounds(radius, 100); i++)
                {
                    selectChannel("Max");
                    dupDocLR.activeLayer.applyMaximum(100);
                    selectChannel("Min");
                    dupDocLR.activeLayer.applyMinimum(100);
                }        
        case false: 
            if ((radius % 100) != 0)
            {
                selectChannel("Max");
                dupDocLR.activeLayer.applyMaximum(radius % 100);
                selectChannel("Min");
                dupDocLR.activeLayer.applyMinimum(radius % 100);	
            }
            else
            {
                selectChannel("Max");
                dupDocLR.activeLayer.applyMaximum(100);
                selectChannel("Min");
                dupDocLR.activeLayer.applyMinimum(100);
            }
    }

    var gBlurRadius = radius*GBLURFACTOR;
    
    switch (gBlurRadius > 250)
    {
        case true:
            for (var j = 1; j<filterRounds(gBlurRadius, 250); j++)
            {
                selectChannel("Max");
                dupDocLR.activeLayer.applyGaussianBlur(250);
                selectChannel("Min");
                dupDocLR.activeLayer.applyGaussianBlur(250);
            }
            
        case false:
            if ((gBlurRadius % 250) != 0)
            {
                selectChannel("Max");
                dupDocLR.activeLayer.applyGaussianBlur(gBlurRadius % 250);
                selectChannel("Min");
                dupDocLR.activeLayer.applyGaussianBlur(gBlurRadius % 250);
            }
            else // theoretically should never occur! ToDo: test.
            {
                selectChannel("Max");
                dupDocLR.activeLayer.applyGaussianBlur(250);
                selectChannel("Min");
                dupDocLR.activeLayer.applyGaussianBlur(250);	
            }
    }

    var maxHalo = max.duplicate(); // Max duplicate for haloing killer
    maxHalo.name = "MaxH";
    var minHalo = min.duplicate(); // Min dublicate for haloing killer
    minHalo.name = "MinH";

    selectChannel("MinH");
    dupDocLR.activeLayer.applyHighPass(radius);
    selectChannel("MaxH");
    dupDocLR.activeLayer.applyHighPass(radius);	

    selectChannel("MaxH");
    myApply("MinH", "Ovrl");
    minHalo.remove()

    dupDocLR.activeChannels = [dupDocLR.channels.getByName("Max")];
    myApply("Min", "Sbtr");
    app.activeDocument.activeLayer.invert();


    // Si torna alla dimensione di un tempo...
    app.activeDocument.resizeImage(actualWidth, actualHeight, docRes, ResampleMethod.BICUBIC);
    app.preferences.rulerUnits = originalPreferences;
    // riporto su myDoc i canali che mi servono...
    max.duplicate(myDoc);
    min.duplicate(myDoc);
    maxHalo.duplicate(myDoc);
   
     
    // chiudo definitivamente il duplicato che è stato a bassa
    dupDocLR.close(SaveOptions.DONOTSAVECHANGES);

    var thisOriginal = myDoc.channels[0].duplicate();
    thisOriginal.name = "thisOriginal";
    selectChannel("Max");
    myApply("thisOriginal", "Mltp");
    selectChannel("thisOriginal");
    myApply("Min", "Sbtr");
    myApply("Max", "Add ");
    myApply("MaxH", "Ovrl");

app.activeDocument.channels.getByName("Max").remove();
app.activeDocument.channels.getByName("Min").remove();
app.activeDocument.channels.getByName("MaxH").remove();
    
    myDoc.activeChannels = [myDoc.channels[0]];
    myApply("thisOriginal", "PrsT");
    myDoc.activeChannels = [myDoc.channels[0], myDoc.channels[1], myDoc.channels[2]];
    thisOriginal.remove();
}

function dimCheck(radius) // gives the reduction factor
{
    var originalPreferences = app.preferences.rulerUnits;
    var currentDim;
    app.preferences.rulerUnits = Units.PIXELS;

    if (app.activeDocument.width > app.activeDocument.height)
    { 
        currentDim = app.activeDocument.width;
    }
    else currentDim = app.activeDocument.height;
    app.preferences.rulerUnits = originalPreferences;
     if ((currentDim<2001 && radius <= 20) || (radius<=10)) {return 1}; // soglia raggio 10 = Fattore sempre 1
    else if (currentDim<2001 && radius > 20) return 2;
    else if (currentDim<3001) return 3;
    else if (currentDim<5001) return 4
    else return 5;
}


function runScript(sname) {
   var file = new File(sname);
   alert(file.path)
   file.open("r");
   var str = file.read();
   file.close();
   return eval(str);
};

function Batch() 
{
// runScript(batch.jsx)
var scriptsPath = app.path + "/" + localize("$$$/ScriptingSupport/InstalledScripts=Presets/Scripts");
var myBatch = File (scriptsPath + "/ALCE21_Batch.jsx")
//var myBatch = File (scriptsPath + "/Image Processor.jsx")
// alert(myBatch);
$.evalFile(myBatch)

}

 function AboutMe() {
alert ("ALCE Version 2.0.0\n(c) 2010 Davide Barranca | bigano.com\nPlease visit www.bigano.com for updates, video-tutorials, documentation and news.")	
	}